/****************************************************************************/
/**    GNOM - Gnom Is NOt MCuT                                             **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/**  Funktionen fr die Remote-Befehle (//SOWISO)                          **/
/****************************************************************************/


#include "global.h"
#include "remote.h"

#include "toolbox.h"
#include "speaker.h"
#include "utils.h"
#include "sndqueue.h"
#include "display.h"
#include "comm.h"
#include "convert.h"

#include <string.h>
#include <dirent.h>


#define ANZ_REMOTECMD 13
char RemoteCommands[ANZ_REMOTECMD][20]={"QUIT",
                                        "VERSION",
                                        "CS",
                                        "NAME",
                                        "COMP",
                                        "WRITE",
                                        "READ",
                                        "INFO",
                                        "HELP",
                                        "RING",
                                        "ECHO",
                                        "RTT",
                                        "DIR"};




/* Auswertung der Remote-Kommandos */
void remote_command(char *command, int length, int chan)
{
  char params[500],str[500],str1[500],str2[500];
  int len,i,found=0;
  
  if (length == 0) return;
  command[length] = '\0';
  
  KillSpacesRight(command);
  if ((i = POS('\xD',command)) != -1) command[i] = '\0';
  
  /* Gucken, ob evtl. ein Parameter mitgegeben wurde */
  if ((i = POS(' ',command)) != -1)
  {
    COPY(params,command,i+1,strlen(command));
    command[i] = '\0';
    
    KillSpacesLeft(params);
  }
  else params[0] = '\0';
  
  Gross(command);
  len = strlen(command);
  
  /* Gucken, ob einfach nur ein Text an einen anderen Kanal geschickt werden soll */
  i = atoi(command);
  if ((i > 0) && (i <= chancount))
  {
    remote_textsend(i,chan,params);
    return;
  }
  
  i = 0;
  while (!found) {
    COPY(str1,command,0,len);
    COPY(str2,RemoteCommands[i],0,len);
    if (!strcmp(str1,str2))
       found = 1;
    else
       i++;
    if (i>ANZ_REMOTECMD) found=1;
  }
  
  if (i>ANZ_REMOTECMD) {
    strcpy(str,"<GNOM>: Unknown command!\xD");
    send_Textline(chan,str);
  }
  else {
    if (i<=ANZ_REMOTECMD) {
      switch(i) {
        case  0: remote_Quit(chan); break;		/* //QUIT */
        case  1: remote_Version(chan); break;		/* //VERSION */
        case  2: remote_chanstat(chan); break;		/* //CS */
        case  3: remote_name(chan,params); break;	/* //NAME */
        case  4: remote_comp(chan,params); break;	/* //COMP [0|1] */
        case  5: remote_write(chan,params); break;	/* //WRITE <filename> */
        case  6: remote_read(chan,params); break;	/* //READ <filename> */
        case  7: remote_info(chan); break;		/* //INFO */
        case  8: remote_help(chan); break;		/* //HELP */
        case  9: remote_ring(chan); break;		/* //RING */
        case 10: remote_echo(chan,params); break;	/* //ECHO */
        case 11: remote_rtt(chan, params); break;	/* //RTT [<timestamp>] */
        case 12: remote_dir(chan, params); break;	/* //DIR [directory] */
      }
    }
  }
}




/* Schickt den bergebenen Text von tochan nach fromchan */
void remote_textsend(int tochan, int fromchan, char *text)
{
  char tmp[1000];
  
  if (tochan == fromchan)
  {
    send_Textline(fromchan,"<GNOM>: Don't do such boring things, please. It's your own channel!\xD");
    return;
  }
  
  if (chaninfo[tochan]->driverfd == -1)
  {
    sprintf(tmp,"<GNOM>: Channel %i is not connected.\xD",tochan);
    send_Textline(fromchan,tmp);
    return;
  }
  
  if (chaninfo[tochan]->type == TYPE_MAILBOX)
  {
    sprintf(tmp,"<GNOM>: %s is a mailbox. Writing is not possible.\xD",chaninfo[tochan]->call);
    send_Textline(fromchan,tmp);
    return;
  }

  if (chaninfo[tochan]->type == TYPE_DIGI)
  {
    sprintf(tmp,"<GNOM>: %s is a digipeater. Writing is not possible.\xD",chaninfo[tochan]->call);
    send_Textline(fromchan,tmp);
    return;
  }
  
  sprintf(tmp,"<%i:%s>: %s\xD",fromchan,chaninfo[fromchan]->call,text);
  send_Textline(tochan,tmp);
}



/* Wenn CS_PROMPT 1 ist, wird ein Prompt ausgesendet */
void check_send_prompt(int chan)
{
  char tmp[200];
  if ((chaninfo[chan]->flags & CH_PROMPT) == CH_PROMPT)
  {
    sprintf(tmp,"%s de %s>\xD",chaninfo[chan]->call,chaninfo[chan]->mycall);
    send_Textline(chan,tmp);
  }
}



void remote_name(int chan, char *param)
{
  char tmp[100];
  
  if (param[0] == '\0')
  {
    if (chaninfo[chan]->name == NULL)
       strcpy(tmp,"Kein Name eingestellt.\xD");
    else
       sprintf(tmp,"Eingestellter Name: %s.\xD",chaninfo[chan]->name);
    send_Textline(chan,tmp);
    check_send_prompt(chan);
    return;
  }
  
  conv_uml_ascii2iso(param);
  
  if (strlen(param) > 20) param[21] = '\0';
  
  chaninfo[chan]->name = (char *)strdup(param);
  setname(chaninfo[chan]->call,chaninfo[chan]->name);
  sprintf(tmp,"OK, %s, Dein Name wurde gespeichert.\xD",chaninfo[chan]->name);
  send_Textline(chan,tmp);
  check_send_prompt(chan);
}



void remote_Quit(int chan)
{
  char tmp[100];
  
  sprintf(tmp,"%s/qtext.gnom",config->maindir);
  send_macrofile(tmp,chan);
  
  if ((chaninfo[chan]->flags & CH_COMP) == CH_COMP)
     send_Textline(chan,"\r//COMP 0\r");
  
  chaninfo[chan]->flags |= CH_DISC;
}



void remote_Version(int chan)
{
  char tmp[100];
  struct tm sTm;
  s_hardware *hard;
  s_port_info *ports;
  int i,k;
  
  
  sTm = *gmtime(&starttime);
  
  sprintf(tmp,"GNOM/Linux V%i.%i.%i (%s)\xD",MAJORLEVEL,MINORLEVEL,PATCHLEVEL,DATUM);
  send_Textline(chan,tmp);
  send_Textline(chan,"Copyright (C) 1997 Jochen Sarrazin, DG6VJ\xD");
  
/*  if ((freemem = get_freemem()) != -1)
     sprintf(tmp,"Coreleft %i kBytes, running since %.2i.%.2i.%.2i %.2i:%.2i:%.2i\xD"
                ,freemem,sTm.tm_mday,sTm.tm_mon+1,sTm.tm_year,sTm.tm_hour+1,sTm.tm_min,sTm.tm_sec);
  else*/
     sprintf(tmp,"Running since %.2i.%.2i.%.2i %.2i:%.2i:%.2i\xD"
                ,sTm.tm_mday,sTm.tm_mon+1,sTm.tm_year,sTm.tm_hour,sTm.tm_min,sTm.tm_sec);
  send_Textline(chan,tmp);
  
  hard = hardware;
  i = 0;
  while (hard != NULL)
  {
    sprintf(tmp,"driver %i: %s V%s by %s\xD",i,hard->name,hard->version,hard->autor);
    send_Textline(chan,tmp);
    ports = hard->ports;
    k = 0;
    while (ports != NULL)
    {
      sprintf(tmp,"  port %i: %s %i baud (%s)\xD",k,ports->port,ports->baud,ports->desc);
      send_Textline(chan,tmp);
      ports = ports->next;
      k++;
    }
    hard = hard->next;
    i++;
  }
  
  check_send_prompt(chan);
}



void remote_chanstat(int chan)
{
  int i=1;
  char tmp[100];

  /* berschrift */
  send_Textline(chan,"  Ch     Port      From       To          Name\xD");
  send_Textline(chan,"-----------------------------------------------------------------\xD");
  
  while (i <= chancount)
  {
    if (chaninfo[i]->driverfd != -1)
    {
      if (chan ==  i)
         sprintf(tmp,"* %3i %8s %10s - %-10s",i,chaninfo[i]->port,chaninfo[i]->call,chaninfo[i]->mycall);
      else
         sprintf(tmp,"  %3i %8s %10s - %-10s",i,chaninfo[i]->port,chaninfo[i]->call,chaninfo[i]->mycall);
         
      if (chaninfo[i]->name != NULL)            
         sprintf(tmp,"%s %-20s\xD",tmp,chaninfo[i]->name);
      else
         sprintf(tmp,"%s%20s\xD",tmp,"");
      send_Textline(chan,tmp);
    }
    i++;
  }
  check_send_prompt(chan);
}



void remote_comp(int chan, char *param)
{
  int zahl;

  Gross(param);
  if (!strcmp(param,"ON"))
  {
    send_Textline(chan,"//COMP 1\r");
    chaninfo[chan]->flags |= CH_COMP;
    update_upper_statusline(TRUE);
    return;
  }

  if (!strcmp(param,"OFF"))
  {
    send_Textline(chan,"//COMP 0\r");
    chaninfo[chan]->flags &= ~CH_COMP;
    update_upper_statusline(TRUE);
    return;
  }

  zahl = atoi(param);

  switch (zahl)
  {
    case 0: if ((chaninfo[chan]->flags & CH_COMP) == 0) return;
            chaninfo[chan]->flags &= ~CH_COMP;
            break;
    case 1: if ((chaninfo[chan]->flags & CH_COMP) == CH_COMP) return;
            chaninfo[chan]->flags |= CH_COMP;
            break;
  }
  update_upper_statusline(TRUE);
}



void remote_write(int chan, char *param)
{
  char tmp[500],fullname[500];
  int fd;
  int i;
  
  
  if ((chaninfo[chan]->flags & (CH_AUTOBINRX|CH_AUTOBINTX)) != 0)
  {
    send_Textline(chan,"<GNOM>: No //WRITE while AutoBIN-Transfer.\r");
    return;
  }
  
  if (param[0] == '\0')
  {
    send_Textline(chan,"<GNOM>: Syntax: //WRITE <filename>\r");
    return;
  }
  
  
  /* Eine Station von 'drauen' soll nur in einem einzigen Verzeichnis 'rummatschen drfen.
   * deshalb schneiden wir alle angegebenen Verzeichnisse ab, und packen das 'down'-Verzeichnis
   * davor.
   */
  while ((i = POS('/',param)) != -1) COPY(param,param,i+1,strlen(param)-i-1); 
  while ((i = POS('\\',param)) != -1) COPY(param,param,i+1,strlen(param)-i-1); 
  
  sprintf(fullname,"%s/down/%s",config->maindir,param);
  
  
  if (file_exist(fullname))
  {
    sprintf(tmp,"<GNOM>: File '%s' already exists. Write aborted.\r",param);
    send_Textline(chan,tmp);
    return;
  }
  
  if ((fd = open(fullname,O_WRONLY|O_CREAT)) == -1)
  {
    sprintf(tmp,"<GNOM>: Cannot open '%s'.\r",param);
    send_Textline(chan,tmp);
    return;
  }
  
  /* Zugriffsrechte einstellen */
  fchmod(fd,S_IRUSR|S_IWUSR);
  
  sprintf(tmp,"<GNOM>: '%s' is open now. Close it with '***END' or CTRL-Z.\r",param);
  send_Textline(chan,tmp);
  
  chaninfo[chan]->flags |= CH_SAVE;
  chaninfo[chan]->saveplain = (s_saveplain *)malloc(sizeof(s_saveplain));
  chaninfo[chan]->saveplain->fd = fd;
  chaninfo[chan]->saveplain->filename = (char *)strdup(fullname);
  chaninfo[chan]->saveplain->local = 2;
  update_upper_statusline(TRUE);
}



void remote_read(int chan, char *param)
{
  char tmp[500];
  int i;

  if ((chaninfo[chan]->flags & (CH_AUTOBINRX|CH_AUTOBINTX)) != 0)
  {
    send_Textline(chan,"<GNOM>: No //READ while AutoBIN-Transfer.\r");
    return;
  }
  
  if (param[0] == '\0')
  {
    send_Textline(chan,"<GNOM>: Syntax: //READ <filename>\r");
    return;
  }
  
  while ((i = POS('/',param)) != -1) COPY(param,param,i+1,strlen(param)-i-1); 
  while ((i = POS('\\',param)) != -1) COPY(param,param,i+1,strlen(param)-i-1); 
  
  sprintf(tmp,"%s/up/%s",config->maindir,param);
  
  if (!file_exist(tmp))
  {
    sprintf(tmp,"'%s' is not available.\r",param);
    send_Textline(chan,tmp);
  }
  
  send_Plainfile(chan,tmp);
}



void remote_info(int chan)
{
  char tmp[500];

  sprintf(tmp,"%s/info.gnom",config->maindir);
  
  if (!file_exist(tmp))
     send_Textline(chan,"<GNOM>: No info available.\r");
  else
     send_macrofile(tmp,chan);
  
  check_send_prompt(chan);
}



void remote_help(int chan)
{
  char tmp[500];

  sprintf(tmp,"%s/help.gnom",config->maindir);
  
  if (!file_exist(tmp))
     send_Textline(chan,"<GNOM>: No help available.\r");
  else
     send_macrofile(tmp,chan);
  
  check_send_prompt(chan);
}



/* //RING - Bimmel */
void remote_ring(int chan)
{
  char tmp[500];

  if ((config->tones->ringok == FALSE) || (config->tones->ring == NULL))
  {
    strcpy(tmp,"<GNOM>: Sri, bell is off.\r");
    send_Textline(chan,tmp);
    return;
  }

  sprintf(tmp,"<GNOM>: Ok, %s is being called. Please wait.\r",chaninfo[chan]->mycall);
  send_Textline(chan,tmp);

  speaker_playstring(config->tones->ring);
}



void remote_echo(int chan, char *str)
{
  char *tmp;
  int len;
  
  len = strlen(str);
  tmp = (char *) malloc(len+2);
  strcpy(tmp,str);
  tmp[len] = '\r';
  tmp[len+1] = '\0';

  send_Textline(chan, tmp);
  
  free(tmp);
}



void remote_rtt(int chan, char *str)
{
  time_t akttime,rxtime,difftime;
  char tmp[500],*diffstr; 


  akttime = time(NULL);
  
  if (str[0] == '\0')
  {
    /* Kein Parameter. Aktuelle Zeit mit //ECHO zurck senden */
    sprintf(tmp,"//ECHO //RTT %lX\r",akttime);
    send_Textline(chan, tmp);
    return;
  }
  
  rxtime = get_hex (str);

  if (rxtime < 1)
  {
    send_Textline(chan, "<GNOM>: Wrong parameter.\r");
    return;
  }

  if ((difftime = akttime - rxtime) == 0)
     sprintf(tmp,"<GNOM>: RTT %s <-> %s <-> %s is less than one second!\r",
                 chaninfo[chan]->mycall, chaninfo[chan]->call, chaninfo[chan]->mycall);
  else
  {
    diffstr = (char *) spec_time(difftime);
    sprintf(tmp,"<GNOM>: RTT %s <-> %s <-> %s is %s.\r",
                chaninfo[chan]->mycall, chaninfo[chan]->call, chaninfo[chan]->mycall,diffstr);
    free(diffstr);
  }
  send_Textline(chan, tmp);
}



/* Zeigt den Inhalt eines Verzeichnisses an. Das Verzeichnis ist immer Relativ zum
 * Verzeichnis ./up!
 */
void remote_dir(int chan, char *str)
{
  char dir[500],tmp[500];
  DIR *dirptr;
  struct dirent *entry;
  
  if (strlen(str) > 200) str[201] = '\0';
  
  if (str[0] == '\0')
     sprintf(dir,"%s/up/",config->maindir);
  else
     sprintf(dir,"%s/up/%s/",config->maindir,str);
  
  dirptr = opendir(dir);
  
  sprintf(tmp,"\rDirectory %s:\xD",dir);
  send_Textline(chan,tmp);
  while ((entry = readdir(dirptr)) != NULL)
  {
    sprintf(tmp,"%s\xD",entry->d_name);
    send_Textline(chan,tmp);
  }
  
  check_send_prompt(chan);
  
  closedir(dirptr);
}



