/****************************************************************************/
/**    GNOM - Gnom Is NOt MCuT                                             **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/**  Routinen, die zur am Programmstart und beim Programmende bentigt     **/
/**  werden.                                                               **/
/****************************************************************************/


#include "global.h"
#include "startup.h"

#include "utils.h"
#include "toolbox.h"

#include <string.h>


/* gnom.conf einlesen.
 * Rckgabe: FALSE, wenn Fehler, TRUE wenn OK
 */
int read_gnom_conf()
{
  FILE *fs;
  char tmp[5000],tmp2[5000];
  int i,line,error=FALSE,found;

  if ((fs = fopen("gnom.conf","r")) == NULL)
  {
    if ((fs = fopen("/etc/gnom.conf","r")) == NULL)
    {
      printf("ERROR! Neither ./gnom.conf nor /etc/gnom.conf were found\n");
      return(FALSE);
    }
  }

  /* Speicher reservieren fr die Config-Geschichte */
  config = (s_config *) malloc(sizeof(s_config));
  
  /* Speicher reservieren fr die Tones-Struktur */
  config->tones = (s_tones *) malloc(sizeof(s_tones));
  /* neue Standardwerte */
  config->tones->con = NULL;			/* Connect-Signal */
  config->tones->disc = NULL;			/* Disconnect-Signal */
  config->tones->bell = TRUE;			/* Ja, wir wollen bimmeln */
  config->tones->ringok = TRUE;			/* //RING - Klingel einschalten */
  config->tones->ring = NULL;			/* //RING - Bimmel */
  config->tones->klack = TRUE;

  /* Speicher reservieren fr die Away-Texte */
  config->awaytxt = (s_away_texte *) malloc(sizeof(s_away_texte));
  /* Standard-Werte */
  config->awaytxt->weg =  NULL;
  config->awaytxt->da = NULL;
  config->awaytxt->telefon = NULL;
  config->awaytxt->sleep = NULL;

  /* Standardwerte */
  config->mycall[0] = '\0';
  config->maindir[0] = '\0';
  config->driver_sockets = NULL;
  config->stdport[0] = '\0';
  config->tabsize = 8;
  config->clock = TRUE;
  config->width = 80;
  
  chancount = -1;
  maxscrolllines = -1;
  maxvorschreiblines = -1;
  pos_statusline = -1;
  framesize = -1;
  maxframe = -1;
  rx_upper = -1;
  rx_lower = -1;
  tx_upper = -1;
  tx_lower = -1;
  colors[0] = -1;
  colors[8] = -1;
  colors[1] = -1;
  colors[2] = -1;
  colors[7] = -1;
  colors[6] = -1;
  colors[3] = -1;
  colors[4] = -1;
  colors[5] = -1;
  colors[9] = -1;
  colors[10] = -1;
  colors[11] = -1;
  colors[12] = -1;
  colors[13] = -1;
  colors[14] = -1;
  
  
  line = 0;
  while (fgets(tmp,256,fs) != NULL)
  {
    line++;
    if (tmp[0] != '#')
    {
      if ((i = POS('\xA',tmp)) != -1) tmp[i] = '\0';
    
      /* Spaces Links und Rechts vom String lschen */
      KillSpacesLeft(tmp);
      KillSpacesRight(tmp);
    
      if ((i = POS(' ',tmp)) == -1)
         printf("gnom.conf: line %i: syntax error\n",line);
      else
      {
        COPY(tmp2,tmp,i+1,strlen(tmp)-i-1);
        tmp[i] = '\0';
        Gross(tmp);
        
        KillSpacesLeft(tmp2);
        KillSpacesRight(tmp2);
        found = FALSE;
        
        if (!strcmp(tmp,"MYCALL"))
        {
          Gross(tmp2);
          strcpy(config->mycall,tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"MAINDIR"))
        {
          strcpy(config->maindir,tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"DRIVER_SOCKETS"))
        {
          config->driver_sockets = (char *)strdup(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"STDPORT"))
        {
          strcpy(config->stdport,tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"CHANCOUNT"))
        {
          chancount = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"MAXSCROLL"))
        {
          maxscrolllines = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"MAXVORSCHREIB"))
        {
          maxvorschreiblines = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"POS_STATUSLINE"))
        {
          pos_statusline = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"FRAMESIZE"))
        {
          framesize = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"MAXFRAME"))
        {
          maxframe = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"RX_UPPER"))
        {
          rx_upper = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"RX_LOWER"))
        {
          rx_lower = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"TX_UPPER"))
        {
          tx_upper = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"TX_LOWER"))
        {
          tx_lower = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"WIDTH"))
        {
          config->width = atoi(tmp2);
          found = TRUE;
        }
        
        /****************************** FARBEN *************************************/
        if (!strcmp(tmp,"COLORS_FORE_STATUS"))	/* Fordergrund Statuszeilen */
        {
          colors[0] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_BACK_STATUS"))	/* Hintergrund Statuszeilen */
        {
          colors[1] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_BACK_STATUS_TRANS"))
        {
          colors[8] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_FORE_SEND_RX"))
        {
          colors[2] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_FORE_REC_RX"))
        {
          colors[7] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_FORE_SYS_RX"))
        {
          colors[6] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_BACK_RX"))
        {
          colors[3] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_FORE_TX"))
        {
          colors[4] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_BACK_TX"))
        {
          colors[5] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_MONI_BACK"))
        {
          colors[9] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_MONI_PORT"))
        {
          colors[10] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_MONI_PROTO"))
        {
          colors[11] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_MONI_ADDR"))
        {
          colors[12] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_MONI_AXHDR"))
        {
          colors[13] = atoi(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"COLORS_MONI_DATA"))
        {
          colors[14] = atoi(tmp2);
          found = TRUE;
        }
        
        /********************************************************************/
        if (!strcmp(tmp,"TONES_CONNECT"))
        {
          config->tones->con = (char *) strdup(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"TONES_DISCONNECT"))
        {
          config->tones->disc = (char *) strdup(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"TONES_RING"))
        {
          config->tones->ring = (char *) strdup(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"SPEAKER_KLACK"))
        {
          switch (tmp2[0])
          {
            case 'Y':
            case 'J': config->tones->klack = TRUE; break;
            case 'N': config->tones->klack = FALSE; break;
          }
          found = TRUE;
        }
        
        
        /********************************************************************/
        if (!strcmp(tmp,"AWAY_BACKAGAIN"))
        {
          config->awaytxt->da = (char *) strdup(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"AWAY_NOTHERE"))
        {
          config->awaytxt->weg = (char *) strdup(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"AWAY_TELEFON"))
        {
          config->awaytxt->telefon = (char *) strdup(tmp2);
          found = TRUE;
        }
        if (!strcmp(tmp,"AWAY_SLEEP"))
        {
          config->awaytxt->sleep = (char *) strdup(tmp2);
          found = TRUE;
        }
        
        
        
        if (!found)
        {
          printf("gnom.conf: line %i: wrong keyword (%s)\n",line,tmp);
/*          error = TRUE;*/
        }
      }
    }
  }
  
  fclose(fs);


  /* Test, ob die einzelnen Felder auch vorkamen */
  if (config->mycall[0] == '\0')
  {
    printf("gnom.conf: 'mycall'-line missing\n");
    error = TRUE;
  }
  if (config->maindir[0] == '\0')
  {
    printf("gnom.conf: 'maindir'-line missing\n");
    error = TRUE;
  }
  if (config->driver_sockets == NULL)
  {
    printf("gnom.conf: 'driver_sockets'-line missing\n");
    error = TRUE;
  }
  if (config->stdport[0] == '\0')
  {
    printf("gnom.conf: 'stdport'-line missing\n");
    error = TRUE;
  }
  if (chancount == -1)
  {
    printf("gnom.conf: 'chancount'-line missing\n");
    error = TRUE;
  }
  if (maxscrolllines == -1)
  {
    printf("gnom.conf: 'maxscroll'-line missing\n");
    error = TRUE;
  }
  if (maxvorschreiblines == -1)
  {
    printf("gnom.conf: 'maxvorschreib'-line missing\n");
    error = TRUE;
  }
  if (pos_statusline == -1)
  {
    printf("gnom.conf: 'pos_statusline'-line missing\n");
    error = TRUE;
  }
  if (framesize == -1)
  {
    printf("gnom.conf: 'framesize'-line missing\n");
    error = TRUE;
  }
  if (maxframe == -1)
  {
    printf("gnom.conf: 'maxframe'-line missing\n");
    error = TRUE;
  }
  if (rx_upper == -1)
  {
    printf("gnom.conf: 'rx_upper'-line missing\n");
    error = TRUE;
  }
  if (rx_lower == -1)
  {
    printf("gnom.conf: 'rx_lower'-line missing\n");
    error = TRUE;
  }
  if (tx_upper == -1)
  {
    printf("gnom.conf: 'tx_upper'-line missing\n");
    error = TRUE;
  }
  if (tx_lower == -1)
  {
    printf("gnom.conf: 'tx_lower'-line missing\n");
    error = TRUE;
  }
  if (colors[0] == -1)
  {
    printf("gnom.conf: 'colors_fore_status'-line missing\n");
    error = TRUE;
  }
  if (colors[1] == -1)
  {
    printf("gnom.conf: 'colors_back_status'-line missing\n");
    error = TRUE;
  }
  if (colors[2] == -1)
  {
    printf("gnom.conf: 'colors_fore_send_rx'-line missing\n");
    error = TRUE;
  }
  if (colors[7] == -1)
  {
    printf("gnom.conf: 'colors_fore_rec_rx'-line missing\n");
    error = TRUE;
  }
  if (colors[6] == -1)
  {
    printf("gnom.conf: 'colors_fore_sys_rx'-line missing\n");
    error = TRUE;
  }
  if (colors[3] == -1)
  {
    printf("gnom.conf: 'colors_back_rx'-line missing\n");
    error = TRUE;
  }
  if (colors[4] == -1)
  {
    printf("gnom.conf: 'colors_fore_tx'-line missing\n");
    error = TRUE;
  }
  if (colors[5] == -1)
  {
    printf("gnom.conf: 'colors_back_tx'-line missing\n");
    error = TRUE;
  }
  if (colors[9] == -1)
  {
    printf("gnom.conf: 'colors_moni_back'-line missing\n");
    error = TRUE;
  }
  if (colors[10] == -1)
  {
    printf("gnom.conf: 'colors_moni_port'-line missing\n");
    error = TRUE;
  }
  if (colors[11] == -1)
  {
    printf("gnom.conf: 'colors_moni_proto'-line missing\n");
    error = TRUE;
  }
  if (colors[12] == -1)
  {
    printf("gnom.conf: 'colors_moni_addr'-line missing\n");
    error = TRUE;
  }
  if (colors[13] == -1)
  {
    printf("gnom.conf: 'colors_moni_axhdr'-line missing\n");
    error = TRUE;
  }
  if (colors[14] == -1)
  {
    printf("gnom.conf: 'colors_moni_data'-line missing\n");
    error = TRUE;
  }
  
  if (colors[8] == -1)
  {
    /* Keine Einfrbung bei AutoBIN/7plus-Transfers */
    colors[8] = colors[1];
  }
  if (config->awaytxt->da == NULL)
     config->awaytxt->da = (char *) strdup("Wiiiilmaaaaaaaaaaaa!!!!! Ich bin wieder daaaaaaaaa..... [%a]");
  if (config->awaytxt->weg == NULL)
     config->awaytxt->weg = (char *) strdup("Mal eben wech, %n... Kurz oder lnger... [%a]");
  if (config->awaytxt->telefon == NULL)
     config->awaytxt->telefon = (char *) strdup("Ma eben teflonieren... [%a]");
  if (config->awaytxt->sleep == NULL)
     config->awaytxt->sleep = (char *) strdup("Gute n8! Ab in die Falle... [%a]");
  
  
  if (!error)
  {
    if (tx_upper > tx_lower)
    {
      printf("gnom.conf: tx_lower must be larger than tx_upper\n");
      error = TRUE;
    }
    if (rx_upper > rx_lower)
    {
      printf("gnom.conf: rx_lower must be larger than rx_upper\n");
      error = TRUE;
    }
    if (tx_lower == 0)
    {
      printf("gnom.conf: tx_lower cannot be 0.\n");
      error = TRUE;
    }
    if (tx_upper == 0)
    {
      printf("gnom.conf: tx_upperr cannot be 0.\n");
      error = TRUE;
    }
    if (rx_lower == 0)
    {
      printf("gnom.conf: rx_lower cannot be 0.\n");
      error = TRUE;
    }
    if (rx_upper == 0)
    {
      printf("gnom.conf: rx_upper cannot be 0.\n");
      error = TRUE;
    }
    if ((tx_upper < pos_statusline) && (tx_lower > pos_statusline))
    {
      printf("gnom.conf: pos_statusline cannot be in the tx-window!\xD");
      error = TRUE;
    }
    if ((rx_upper < pos_statusline) && (rx_lower > pos_statusline))
    {
      printf("gnom.conf: pos_statusline cannot be in the rx-window!\xD");
      error = TRUE;
    }
  }

  fflush(stdout);

  if (error)
  {
    printf("\n");
    fflush(stdout);
    return(FALSE);
  }
  return(TRUE);
}


void program_break()
{
}


void build_vorschreibbuffer(int chan)
{
  int k;
  s_vorschreib *new,*last;


  /* Den Scrollbuffer initialisieren */
  last = NULL;			/* Kein letztes Feld - wir sind oben in der Liste */
  
  /* Erste Scrollzeile */
  if ((new = (s_vorschreib *)malloc(sizeof(s_vorschreib))) == NULL) {
    /* Kein Speicher mehr frei */
    printf("ERROR! Not enough memory!\n");
    _exit(10);
  }
  new->last = NULL;
  new->text[0] = '\0';
  new->len = 0;
  chaninfo[chan]->vor_upper = new;
  
  k = 1;
  while (k < maxvorschreiblines)
  {
    /* Letzte Zeile merken */
    last = new;
    if ((new->next = (s_vorschreib *)malloc(sizeof(s_vorschreib))) == NULL) {
      /* Kein Speicher mehr frei */
      printf("ERROR! Not enough memory!\n");
      _exit(10);
    }
    new = new->next;
    new->last = last;
    new->text[0] = '\0';
    new->len = 0;
    k++;
  }
  new->next = chaninfo[chan]->vor_upper;		/* weil ja Ringbuffer */
  chaninfo[chan]->vor_upper->last = new;		/* weil ja Ringbuffer */
  chaninfo[chan]->vor_lower = new;
  chaninfo[chan]->vor_act = chaninfo[chan]->vor_upper;	/* Die aktuelle ist die erste Zeile */
  chaninfo[chan]->vor_screen = chaninfo[chan]->vor_act;
}


void build_scrollbuffer(int chan)
{
  int k;
  s_scroll *new,*last;
  
  last = NULL;			/* Kein letztes Feld - wir sind oben in der Liste */
  
  /* Erste Scrollzeile */
  if ((new = (s_scroll *)malloc(sizeof(s_scroll))) == NULL) {
    /* Kein Speicher mehr frei */
    printf("ERROR! Not enough memory!\n");
    _exit(10);
  }
  new->last = NULL;
  new->text = NULL;			/* Kein Text */
  new->blen = 0;
  chaninfo[chan]->scroll_upper = new;
  
  k = 1;
  while (k < maxscrolllines)
  {
    /* Letzte Zeile merken */
    last = new;
    if ((new->next = (s_scroll *)malloc(sizeof(s_scroll))) == NULL) {
      /* Kein Speicher mehr frei */
      printf("ERROR! Not enough memory!\n");
      _exit(10);
    }
    new = new->next;
    new->last = last;
    new->text = NULL;			/* Kein Text */
    new->blen = 0;
    k++;
  }
  
  new->next = chaninfo[chan]->scroll_upper;	/* weil ja Ringbuffer */
  chaninfo[chan]->scroll_upper->last = new;	/* weil ja Ringbuffer */
  chaninfo[chan]->scroll_lower = new;
  chaninfo[chan]->scroll_act = chaninfo[chan]->scroll_lower; /* Die aktuelle ist die unterste Zeile */
  chaninfo[chan]->scroll_screen = chaninfo[chan]->scroll_act;
  k = 0;
  while (k < rx_lower-rx_upper+1)
  {
    chaninfo[chan]->scroll_screen = chaninfo[chan]->scroll_screen->last;
    k++;
  }
  chaninfo[chan]->scroll_screen_upper = chaninfo[chan]->scroll_screen;
}


/* Initialisiert die scrollback-Puffer. (Speicher fr die verkettete Liste reservieren etc) */
void init_scrollbuffers()
{
  int i;
  
  i = 0;
  while (i < MAXCHAN) {
    chaninfo[i] = NULL;
    i++;
  }
  
  i = 0;
  while (i <= chancount) {
    /* Speicher fr den chaninfo-Record allokieren */
    if ((chaninfo[i] = (s_chaninfo *)malloc(sizeof(s_chaninfo))) == NULL) {
      /* Kein Speicher mehr frei */
      printf("ERROR! Not enough memory!\n");
      _exit(10);
    }
    
    strcpy(chaninfo[i]->mycall,config->mycall);	/* Eigenes Rufzeichen */
    chaninfo[i]->call[0] = '\0';	/* Rufzeichen der Gegenstation */
    chaninfo[i]->digis = NULL;		/* Digipeater */
    chaninfo[i]->name = NULL;		/* Name der Gegenstation */
    chaninfo[i]->status = 0;		/* Disconnected */
    chaninfo[i]->flags = CH_STDFLAGS;	/* Flags auf Standard setzen (siehe global.h) */
    chaninfo[i]->oldflags = 0;
    chaninfo[i]->convert_rx = 1;	/* Standard-Wandlung: Nach ASCII */
    chaninfo[i]->convert_tx = 1;	/* Standard-Wandlung: Nach ASCII */
    chaninfo[i]->consstat = 0;		/* Nix */
    
    /* Cursorposition im Vorschreibpuffer dieses Kanals */
    chaninfo[i]->x_akt = 0;
    chaninfo[i]->y_akt = 0;
    chaninfo[i]->x_screen = 0;
    chaninfo[i]->umbruch = config->width;
    
    /* Anzahl empfangener/Gesendeter Bytes */
    chaninfo[i]->rx_bytes = 0;
    chaninfo[i]->tx_bytes = 0;
    
    /* TNC-Infos */
    chaninfo[i]->tries = 0;
    chaninfo[i]->unack = 0;
    chaninfo[i]->squeue = 0;
    
    chaninfo[i]->driverfd = -1;
    chaninfo[i]->qsonr = -1;
    
    chaninfo[i]->sendqueue = NULL;		/* Noch nix zu senden da */
    chaninfo[i]->rxframes = NULL;
    chaninfo[i]->conncalls = NULL;
    chaninfo[i]->saveplain = NULL;
    chaninfo[i]->autobin = NULL;
    chaninfo[i]->pwinfo = NULL;
    chaninfo[i]->AutoEBIN = NULL;
    
    
    /* Den Scrollpuffer initialisieren */
    build_scrollbuffer(i);
    
    /* Vorschreibpuffer */
    build_vorschreibbuffer(i);
    i++;
  }
}




/* allgemeine globale Variablen Initialisieren */
void init_globals()
{


  ConsoleStatus = 0;
  AktChan = 1;
  
  /* Wann wurde dieser Prozess gestartet? */
  starttime = time(NULL);
  
  portsroot = NULL;
  maxfd = 1;
  
  /* Kein Away-Text - der Operator ist da */
  awaytext = NULL;
}


/* Ntige Verzeichnisse anlegen */
void make_dirs()
{
  char tmp[500];
  
  sprintf(tmp,"%s/abin",config->maindir);
  if (mkdir(tmp,448) == -1) { }

  sprintf(tmp,"%s/userdb",config->maindir);
  if (mkdir(tmp,448) == -1) { }

  sprintf(tmp,"%s/down",config->maindir);
  if (mkdir(tmp,448) == -1) { }

  sprintf(tmp,"%s/up",config->maindir);
  if (mkdir(tmp,448) == -1) { }

  sprintf(tmp,"%s/7plus",config->maindir);
  if (mkdir(tmp,448) == -1) { }

  sprintf(tmp,"%s/log",config->maindir);
  if (mkdir(tmp,448) == -1) { }
}



/* Das File mycalls.gnom auslesen und abhngig davon die Mycalls auf den verschiedenen Kanlen
 * setzen.
 */
void startup_set_mycalls()
{
  FILE *fs;
  char tmp[500],tmp2[101];
  int i,chan;
  
  
  sprintf(tmp,"%s/mycalls.gnom",config->maindir);
  if ((fs = fopen(tmp,"r")) == NULL) return;
  
  while (fgets(tmp,100,fs) != NULL)
  {
    if ((tmp[0] != '#') && (tmp[0] != '\0'))
    {
      if ((i = POS('\xA',tmp)) != -1) tmp[i] = '\0';
      if ((i = POS(' ',tmp)) != -1)
      {
        COPY(tmp2,tmp,0,i);
        KillSpacesRight(tmp2);
        KillSpacesLeft(tmp2);
        COPY(tmp,tmp,i+1,strlen(tmp)-i-1);
        chan = atoi(tmp2);
        if ((chan != 0) && valid_callsign(tmp) && (chan <= chancount))
           if (chaninfo[chan]->driverfd == -1)
           {
             Gross(tmp);
             KillSpacesRight(tmp);
             KillSpacesLeft(tmp);
             strcpy(chaninfo[chan]->mycall,tmp);
           }
      }
    }
  }
  
  fclose(fs);
}



