/****************************************************************************/
/**    GNOM - Gnom Is NOt MCuT                                             **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/**  Hilfs-Funktionen, die auf GNOM festgelegt sind. Funktionen, die auch  **/
/**  von anderen Programmen benutzt werden knnen, sind in toolbox.h.      **/
/****************************************************************************/

#ifndef UTILS_H
#define UTILS_H

#include <sys/types.h>
#ifdef SLANG
#include "slcombat.h"
#else
#include <ncurses.h>
#endif
#include "comm.h"

/****************************************************************************/
/**      In dieser Struktur werden die Userdaten temporr gespeichert.     **/
typedef struct
{
  char call[10];
  char name[50];
  int add_flags;
  int sub_flags;
  int pwmode;
  char password[500];
  int type;
} s_udata;
/****************************************************************************/


/*
*** get_hex: some compilers have real big trouble when reading hex values from
***          a file with fscanf() that have leading zeros! e.g. 00A will be
***          read as two separate values (0 and A)! grr!!
***          get_hex skips all leading zeros to eliminate the problem.
***
 */

uint get_hex (char *hex);


void _randomize();


int _randint(short my_range);


/* randomize erzeugt eine Zufallszahl in den Grenzen LO - HI */
/* wird fuer die Passwordberechnungen gebraucht              */
short dp_randomize(short low, short hiw);


char *spec_time(int zeit);


/* Sucht ein cookie aus dem cookie-File und sendet es auf dem angegebenen Kanal aus. */
void send_cookie(int chan);


/* Guckt, ob noch ein Kanal frei ist */
int chan_free(char *mycall);


void disc_channel(int chan);


void macro_thisline(char *dest, char *src, int chan);


/* Verschickt das bergebene File, und ersetzt die Makros */
void send_macrofile(char *filename, int chan);


void ClearUserData(s_udata *udata);


/* User-Informationen wenn vorhanden aus dem User-Info-File holen und
   in die Datenstruktur schreiben. */
int GetUserData(s_udata *udata);


/* Userdaten in das File schreiben */
void WriteUserData(const s_udata *udata);


/* SSID vom Call abschneiden */
void CutSSID(char *dest, const char *src);


void setname(char *call, char *name);


void settype(char *call, int type);


int valid_callsign(char *call);


/* Holt sich die Userdaten zu dem aktuellen Rufzeichen */
void get_userdata_chan(int channel);


void data_save_frame(char *data, int len, int chan);


int data_next_cr(char *str, int max);


void conncall_addlist(int chan, char *call);


/* Guckt, ob dieses Rufzeichen in der Liste enthalten ist. Wenn ja werden alle Calls
 * ab diesem Rufzeichen aus der Liste gelscht.
 */
int conncall_checkcall(int chan, char *call);


void check_autobin(char *str, int chan);


/* Berechnet die CRC aus einem ganzen String */
unsigned short calc_crcthp_str(const char *str, const int len, unsigned short crc);


void check_7plus_autosave(int chan, char *data, int len);


void check_7plus_saveit(int chan, char *data, int len);


/*
 * AutoBIN-Save ist an.
 * Speichern also
 */
void frame_save_autobin(char *data, int len, int chan);


void data_split_frames(int chan);


unsigned short calc_crctph_wholefile(char *path);


/* Bei jedem neuen Connect werden diese Sachen abgearbeitet */
void todo_on_connect(int chan);


void write_to_chtype(char *str, chtype *chtype_str, int attrib);


void chtype_write_attribs(chtype *attrarray, int start, int count, int attrib);


/*
 * Wandelt nicht darstellbare Zeichen so um, da sie Angezeigt werden knnen (BIN oder so)
 *
 * Genauer werden folgende Sachen gemacht:
 *   - '\0'en im String zu ' ' umgewandelt
 *   - '\xFF'en im String zu ' ' umgewandelt
 *   - '\xA'en werden zu '\xD' umgewandelt
 */
void checkshowchars(char *tmp, int len);


int ax25_get_driverfd(char *portstr);


void delete_this_driver_from_list(s_hardware *hard);


int valid_portname(char *name);


void mycall_addcall(char *call);


/* Diese Funktion guckt, ob das angegebene Mycall auf einem anderen nicht connecteten Port
 * eingestellt ist. Wenn nicht wird der Treiber angewiesen, auf dieses Rufzeiche nicht mehr
 * zu lauschen.
 */
void check_for_mycall_connect(char *mycall);


/* Wenn auf das angegebene mycall nicht gelauscht werden sollte, dem Treiber bescheid
 * sagen, da doch gelauscht werden soll, weil ja der kanal mit diesem Mycall wieder
 * frei wird.
 */
void check_for_mycall_disconnect(char *mycall);


#endif

